max v2;
#N vpatcher 139 44 1186 830;
#P origin -21 -255;
#P setbglock 1;
#P window setfont "Sans Serif" 9.;
#P comment 804 687 170 196617 MSP Overview by Anthony Palumbo;
#N vpatcher 245 125 687 401;
#P origin 6 -57;
#P setbglock 1;
#P window setfont "Sans Serif" 9.;
#P window linecount 0;
#P message 17 207 77 196617 poltocar~;
#P message 17 39 77 196617 cartopol~;
#P hidden newex 270 392 45 196617 pcontrol;
#P hidden newex 270 368 64 196617 prepend help;
#P window setfont "Sans Serif" 14.;
#P comment 9 15 227 196622 FFT;
#P hidden inlet 340 313 15 0;
#P window setfont "Sans Serif" 9.;
#P hidden newex 356 312 38 196617 t front;
#P hidden message 379 158 158 196617 window flags grow \, window exec;
#P hidden message 380 178 239 196617 window flags nogrow \, window exec \, savewindow 1;
#N thispatcher;
#Q window flags nogrow close zoom nofloat;
#Q window size 245 125 687 401;
#Q window title;
#Q window exec;
#Q savewindow 1;
#Q end;
#P hidden newobj 398 312 59 196617 thispatcher;
#P window linecount 1;
#P comment 98 222 169 196617 A vector based envelope follower;
#P message 17 221 77 196617 vectral~;
#P comment 98 208 203 196617 Polar to cartesian coordinate conversion;
#P comment 98 194 159 196617 Wrap a signal between -pi and pi;
#P message 17 193 77 196617 phasewrap~;
#P comment 98 180 258 196617 Subpatch with spectral-domain signal processing chain;
#P message 17 179 77 196617 pfft~;
#P comment 98 166 172 196617 Perform an Inverse FFT on a signal;
#P message 17 165 77 196617 ifft~;
#P comment 98 152 254 196617 Calc phase deviation between successive FFT frames;
#P message 17 151 77 196617 framedelta~;
#P comment 98 138 230 196617 Calc running phase of phase deviation frames;
#P message 17 137 77 196617 frameaccum~;
#P comment 98 124 197 196617 Spectral-domain pitch-shifter for pfft~.;
#P message 17 123 77 196617 gizmo~;
#P comment 98 110 136 196617 Perform an FFT on a signal;
#P message 17 109 77 196617 fft~;
#P comment 98 96 233 196617 Communicate between pfft~ and the outside world;
#P message 17 95 77 196617 fftout~;
#P comment 98 82 240 196617 Communicate between pfft~ and the outside world;
#P message 17 81 77 196617 fftin~;
#P comment 99 68 200 196617 Info about the fft frames loaded by pfft~;
#P message 17 67 77 196617 fftinfo~;
#P comment 99 54 154 196617 Shift a frequency inside a pfft~;
#P message 17 53 77 196617 fbinshift~;
#P comment 99 40 204 196617 Cartesian to polar coordinate conversion.;
#P user panel -1 -2 670 324;
#X brgb 204 204 153;
#X frgb 0 0 0;
#X border 1;
#X rounded 0;
#X shadow 1;
#X done;
#P background;
#P hidden connect 36 0 33 0;
#P hidden connect 35 0 33 0;
#P hidden connect 16 0 33 0;
#P hidden connect 8 0 33 0;
#P hidden connect 25 0 33 0;
#P hidden connect 22 0 33 0;
#P hidden connect 20 0 33 0;
#P hidden connect 18 0 33 0;
#P hidden connect 14 0 33 0;
#P hidden connect 12 0 33 0;
#P hidden connect 10 0 33 0;
#P hidden connect 6 0 33 0;
#P hidden connect 2 0 33 0;
#P hidden connect 4 0 33 0;
#P hidden connect 33 0 34 0;
#P hidden connect 31 0 30 0;
#P hidden connect 30 0 27 0;
#P hidden connect 29 0 27 0;
#P hidden connect 28 0 27 0;
#P pop;
#P hidden newobj 343 554 69 196617 p fft;
#N vpatcher 40 55 717 378;
#P outlet 121 222 15 0;
#P window setfont "Sans Serif" 9.;
#P message 135 161 228 196617 script send __revertbutton__ frgb 255 255 255;
#P message 121 143 192 196617 script send __revertbutton__ frgb 0 0 0;
#P newex 144 55 40 196617 change;
#P message 178 186 65 196617 restorestate;
#P newex 144 77 40 196617 sel 0 1;
#P message 75 107 140 196617 shadow 2 \, brgb 200 200 200;
#P message 109 125 145 196617 shadow -2 \, brgb 140 140 140;
#P outlet 178 222 15 0;
#P inlet 144 36 15 0;
#P inlet 109 36 15 0;
#P inlet 75 36 15 0;
#P outlet 75 222 15 0;
#P connect 1 0 6 0;
#P connect 7 0 6 0;
#P connect 6 0 0 0;
#P connect 5 0 0 0;
#P connect 2 0 5 0;
#P connect 7 1 5 0;
#P connect 1 0 10 0;
#P connect 7 0 10 0;
#P connect 11 0 12 0;
#P connect 10 0 12 0;
#P connect 7 1 11 0;
#P connect 2 0 11 0;
#P connect 3 0 9 0;
#P connect 9 0 7 0;
#P connect 1 0 8 0;
#P connect 8 0 4 0;
#P pop;
#P hidden newobj 509 532 45 196617 p revert;
#P window setfont "Sans Serif" 10.;
#P comment 347 533 138 196618 FFT Overview;
#P objectname __revertbutton__[4];
#P user ubutton 343 531 113 19 0 6;
#P window setfont "Sans Serif" 14.;
#P comment 343 508 203 196622 FFT support;
#P user panel 343 531 114 18;
#X brgb 200 200 200;
#X frgb 0 0 0;
#X border 1;
#X rounded 8;
#X shadow 2;
#X done;
#P window setfont "Sans Serif" 9.;
#N vpatcher 245 125 722 345;
#P origin 7 -75;
#P window setfont "Sans Serif" 9.;
#P window linecount 0;
#P message 17 39 78 196617 hostcontrol~;
#P message 17 53 78 196617 hostphasor~;
#P window setfont "Sans Serif" 14.;
#P comment 9 15 227 196622 Plug-in support;
#P hidden inlet 338 231 15 0;
#P window setfont "Sans Serif" 9.;
#P hidden newex 354 230 38 196617 t front;
#P hidden message 377 139 158 196617 window flags grow \, window exec;
#P hidden message 378 159 239 196617 window flags nogrow \, window exec \, savewindow 1;
#N thispatcher;
#Q window flags nogrow close zoom nofloat;
#Q window size 245 125 722 345;
#Q window title;
#Q window exec;
#Q savewindow 1;
#Q end;
#P hidden newobj 396 230 59 196617 thispatcher;
#P window linecount 1;
#P comment 97 180 207 196617 Hosts VST plug-ins;
#P message 17 179 78 196617 vst~;
#P comment 97 68 221 196617 Get transport control info from a ReWire host;
#P message 17 67 78 196617 hostsync~;
#P comment 97 54 207 196617 phasor~ synchronized with ReWire host;
#P comment 97 40 207 196617 Control a ReWire host's transport;
#P comment 97 109 226 196617 Define a plug-in's audio outputs;
#P comment 97 81 226 196617 Define a plug-in's audio inputs;
#P message 17 109 78 196617 plugout~;
#P message 17 81 78 196617 plugin~;
#P comment 97 165 226 196617 Define a time parameter in multiple formats;
#P comment 97 151 226 196617 Define tempo and sync mode parameters;
#P comment 97 137 226 196617 Define a plug-in parameter;
#P comment 97 123 226 196617 Store a list of numbers in multislider format;
#P comment 97 95 226 196617 Define an array of plug-in parameters;
#P message 17 137 78 196617 pp;
#P message 17 165 78 196617 pptime;
#P message 17 151 78 196617 pptempo;
#P message 17 123 78 196617 plugstore;
#P message 17 95 78 196617 plugmultiparam;
#P hidden newex 128 232 64 196617 prepend help;
#P hidden newex 128 252 45 196617 pcontrol;
#P user panel -1 -2 670 324;
#X brgb 153 153 204;
#X frgb 0 0 0;
#X border 1;
#X rounded 0;
#X shadow 1;
#X done;
#P background;
#P hidden connect 21 0 2 0;
#P hidden connect 30 0 2 0;
#P hidden connect 29 0 2 0;
#P hidden connect 19 0 2 0;
#P hidden connect 3 0 2 0;
#P hidden connect 6 0 2 0;
#P hidden connect 5 0 2 0;
#P hidden connect 4 0 2 0;
#P hidden connect 7 0 2 0;
#P hidden connect 14 0 2 0;
#P hidden connect 13 0 2 0;
#P hidden connect 2 0 1 0;
#P hidden connect 27 0 26 0;
#P hidden connect 24 0 23 0;
#P hidden connect 25 0 23 0;
#P hidden connect 26 0 23 0;
#P pop;
#P hidden newobj 343 614 69 196617 p plugins;
#N vpatcher 245 125 719 406;
#P origin 7 -75;
#P window setfont "Sans Serif" 14.;
#P window linecount 0;
#P comment 9 15 227 196622 Synthesis - oscillators;
#P hidden inlet 338 294 15 0;
#P window setfont "Sans Serif" 9.;
#P hidden newex 354 293 38 196617 t front;
#P hidden message 377 139 158 196617 window flags grow \, window exec;
#P hidden message 378 159 239 196617 window flags nogrow \, window exec \, savewindow 1;
#N thispatcher;
#Q window flags nogrow close zoom nofloat;
#Q window size 245 125 719 406;
#Q window title;
#Q window exec;
#Q savewindow 1;
#Q end;
#P hidden newobj 396 293 59 196617 thispatcher;
#P window linecount 1;
#P comment 88 208 242 196617 antialiased triangle oscillator;
#P message 17 207 70 196617 tri~;
#P comment 88 194 270 196617 Pulse-train generator and metronome;
#P message 17 193 70 196617 train~;
#P comment 88 180 242 196617 antialiased sawtooth oscillator;
#P message 17 179 70 196617 saw~;
#P comment 88 166 241 196617 antialiased rectangle oscillator;
#P message 17 165 70 196617 rect~;
#P comment 88 152 201 196617 Pink noise generator;
#P message 17 151 70 196617 pink~;
#P comment 88 138 242 196617 Sawtooth ramp generator;
#P message 17 137 70 196617 phasor~;
#P comment 88 124 250 196617 an uninterpolated oscillator bank;
#P message 17 123 70 196617 oscbank~;
#P comment 88 110 242 196617 Noise generator;
#P message 17 109 70 196617 noise~;
#P comment 88 96 245 196617 Distort the output of a phasor~;
#P message 17 95 70 196617 kink~;
#P comment 88 82 240 196617 an interpolated oscillator bank;
#P message 17 81 70 196617 ioscbank~;
#P comment 88 68 298 196617 Table-lookup oscillator or function generator;
#P message 17 67 70 196617 cycle~;
#P comment 88 54 330 196617 cosine function for use with 0-1 input from phasor~;
#P message 17 53 70 196617 cos~;
#P comment 88 40 242 196617 generate an impulse;
#P message 17 39 70 196617 click~;
#P hidden newex 128 250 45 196617 pcontrol;
#P hidden newex 128 226 64 196617 prepend help;
#P user panel -1 -2 670 324;
#X brgb 153 204 153;
#X frgb 0 0 0;
#X border 1;
#X rounded 0;
#X shadow 1;
#X done;
#P background;
#P hidden connect 11 0 1 0;
#P hidden connect 7 0 1 0;
#P hidden connect 25 0 1 0;
#P hidden connect 23 0 1 0;
#P hidden connect 21 0 1 0;
#P hidden connect 17 0 1 0;
#P hidden connect 15 0 1 0;
#P hidden connect 13 0 1 0;
#P hidden connect 9 0 1 0;
#P hidden connect 5 0 1 0;
#P hidden connect 3 0 1 0;
#P hidden connect 1 0 2 0;
#P hidden connect 33 0 32 0;
#P hidden connect 32 0 29 0;
#P hidden connect 31 0 29 0;
#P hidden connect 30 0 29 0;
#P pop;
#P hidden newobj 26 238 69 196617 p oscillators;
#N vpatcher 245 125 699 395;
#P origin 8 -35;
#P window setfont "Sans Serif" 9.;
#P window linecount 1;
#P message 17 235 57 196617 teeth~;
#P comment 77 237 323 196617 comb filter with independent feedback and feedforward delay times;
#P message 17 220 57 196617 svf~;
#P comment 77 222 267 196617 state-variable filter;
#P message 17 205 57 196617 slide~;
#P comment 77 207 316 196617 Smooth-out changes in signal values;
#P message 17 190 57 196617 reson~;
#P comment 77 192 361 196617 Bandpass filter (controlled center freq and Q);
#P message 17 175 57 196617 phaseshift~;
#P comment 77 177 281 196617 Allpass phase-shifting filter;
#P message 17 160 57 196617 onepole~;
#P comment 77 162 267 196617 single-pole lowpass filter;
#P message 17 145 57 196617 lores~;
#P comment 77 147 298 196617 Low-pass filter with resonance;
#P message 17 130 57 196617 hilbert~;
#P comment 77 132 296 196617 Phase Quadrature allpass filter;
#P message 17 115 57 196617 fffb~;
#P comment 77 117 250 196617 Fast fixed filter bank;
#P message 17 100 57 196617 comb~;
#P comment 77 102 267 196617 IIR comb filter;
#P message 17 85 57 196617 cascade~;
#P comment 77 87 289 196617 A series of cascaded biquads.;
#P message 17 70 57 196617 buffir~;
#P comment 77 72 326 196617 a buffer~-based FIR convolution filter;
#P message 17 55 57 196617 biquad~;
#P comment 77 57 323 196617 Digital filter specified by coefficients;
#P message 17 40 57 196617 allpass~;
#P comment 77 42 267 196617 Allpass filter;
#P window setfont "Sans Serif" 14.;
#P comment 9 16 227 196622 Filters;
#P window setfont "Sans Serif" 9.;
#P hidden newex 893 11 45 196617 pcontrol;
#P hidden newex 893 -13 64 196617 prepend help;
#P hidden inlet 338 295 15 0;
#P window linecount 0;
#P hidden newex 354 294 38 196617 t front;
#P hidden message 377 140 158 196617 window flags grow \, window exec;
#P hidden message 378 160 239 196617 window flags nogrow \, window exec \, savewindow 1;
#N thispatcher;
#Q window flags nogrow close zoom nofloat;
#Q window size 245 125 699 395;
#Q window title;
#Q window exec;
#Q savewindow 1;
#Q end;
#P hidden newobj 396 294 59 196617 thispatcher;
#P user panel -1 -1 670 324;
#X brgb 204 153 153;
#X frgb 0 0 0;
#X border 1;
#X rounded 0;
#X shadow 1;
#X done;
#P background;
#P hidden connect 5 0 4 0;
#P hidden connect 2 0 1 0;
#P hidden connect 3 0 1 0;
#P hidden connect 4 0 1 0;
#P hidden connect 10 0 6 0;
#P hidden connect 12 0 6 0;
#P hidden connect 14 0 6 0;
#P hidden connect 16 0 6 0;
#P hidden connect 18 0 6 0;
#P hidden connect 20 0 6 0;
#P hidden connect 22 0 6 0;
#P hidden connect 24 0 6 0;
#P hidden connect 26 0 6 0;
#P hidden connect 28 0 6 0;
#P hidden connect 30 0 6 0;
#P hidden connect 32 0 6 0;
#P hidden connect 34 0 6 0;
#P hidden connect 36 0 6 0;
#P hidden connect 6 0 7 0;
#P pop;
#P hidden newobj 26 287 69 196617 p filters;
#N vpatcher 40 55 717 378;
#P outlet 121 222 15 0;
#P window setfont "Sans Serif" 9.;
#P message 135 161 228 196617 script send __revertbutton__ frgb 255 255 255;
#P message 121 143 192 196617 script send __revertbutton__ frgb 0 0 0;
#P newex 144 55 40 196617 change;
#P message 178 186 65 196617 restorestate;
#P newex 144 77 40 196617 sel 0 1;
#P message 75 107 140 196617 shadow 2 \, brgb 200 200 200;
#P message 109 125 145 196617 shadow -2 \, brgb 140 140 140;
#P outlet 178 222 15 0;
#P inlet 144 36 15 0;
#P inlet 109 36 15 0;
#P inlet 75 36 15 0;
#P outlet 75 222 15 0;
#P connect 1 0 6 0;
#P connect 7 0 6 0;
#P connect 5 0 0 0;
#P connect 6 0 0 0;
#P connect 7 1 5 0;
#P connect 2 0 5 0;
#P connect 1 0 10 0;
#P connect 7 0 10 0;
#P connect 10 0 12 0;
#P connect 11 0 12 0;
#P connect 2 0 11 0;
#P connect 7 1 11 0;
#P connect 3 0 9 0;
#P connect 9 0 7 0;
#P connect 1 0 8 0;
#P connect 8 0 4 0;
#P pop;
#P hidden newobj 531 582 45 196617 p revert;
#P window setfont "Sans Serif" 10.;
#P comment 348 583 138 196618 Plug-In Overview;
#P objectname __revertbutton__[3];
#P user ubutton 343 581 113 19 0 6;
#P window setfont "Sans Serif" 14.;
#P comment 343 558 203 196622 Plug-in Support;
#P user panel 343 581 114 18;
#X brgb 200 200 200;
#X frgb 0 0 0;
#X border 1;
#X rounded 8;
#X shadow 2;
#X done;
#P window setfont "Sans Serif" 9.;
#N vpatcher 40 55 717 378;
#P outlet 121 222 15 0;
#P window setfont "Sans Serif" 9.;
#P message 135 161 228 196617 script send __revertbutton__ frgb 255 255 255;
#P message 121 143 192 196617 script send __revertbutton__ frgb 0 0 0;
#P newex 144 55 40 196617 change;
#P message 178 186 65 196617 restorestate;
#P newex 144 77 40 196617 sel 0 1;
#P message 75 107 140 196617 shadow 2 \, brgb 200 200 200;
#P message 109 125 145 196617 shadow -2 \, brgb 140 140 140;
#P outlet 178 222 15 0;
#P inlet 144 36 15 0;
#P inlet 109 36 15 0;
#P inlet 75 36 15 0;
#P outlet 75 222 15 0;
#P connect 1 0 6 0;
#P connect 7 0 6 0;
#P connect 6 0 0 0;
#P connect 5 0 0 0;
#P connect 2 0 5 0;
#P connect 7 1 5 0;
#P connect 1 0 10 0;
#P connect 7 0 10 0;
#P connect 11 0 12 0;
#P connect 10 0 12 0;
#P connect 7 1 11 0;
#P connect 2 0 11 0;
#P connect 3 0 9 0;
#P connect 9 0 7 0;
#P connect 1 0 8 0;
#P connect 8 0 4 0;
#P pop;
#P hidden newobj 208 216 45 196617 p revert;
#P window setfont "Sans Serif" 10.;
#P comment 30 217 138 196618 Oscillator Overview;
#P objectname __revertbutton__[2];
#P user ubutton 26 215 113 19 0 6;
#P window setfont "Sans Serif" 14.;
#P comment 26 192 203 196622 Synthesis - oscillators;
#P user panel 26 215 114 18;
#X brgb 200 200 200;
#X frgb 0 0 0;
#X border 1;
#X rounded 8;
#X shadow 2;
#X done;
#P window setfont "Sans Serif" 9.;
#N vpatcher 40 55 717 378;
#P outlet 121 222 15 0;
#P window setfont "Sans Serif" 9.;
#P message 135 161 228 196617 script send __revertbutton__ frgb 255 255 255;
#P message 121 143 192 196617 script send __revertbutton__ frgb 0 0 0;
#P newex 144 55 40 196617 change;
#P message 178 186 65 196617 restorestate;
#P newex 144 77 40 196617 sel 0 1;
#P message 75 107 140 196617 shadow 2 \, brgb 200 200 200;
#P message 109 125 145 196617 shadow -2 \, brgb 140 140 140;
#P outlet 178 222 15 0;
#P inlet 144 36 15 0;
#P inlet 109 36 15 0;
#P inlet 75 36 15 0;
#P outlet 75 222 15 0;
#P connect 1 0 6 0;
#P connect 7 0 6 0;
#P connect 5 0 0 0;
#P connect 6 0 0 0;
#P connect 7 1 5 0;
#P connect 2 0 5 0;
#P connect 1 0 10 0;
#P connect 7 0 10 0;
#P connect 10 0 12 0;
#P connect 11 0 12 0;
#P connect 2 0 11 0;
#P connect 7 1 11 0;
#P connect 3 0 9 0;
#P connect 9 0 7 0;
#P connect 1 0 8 0;
#P connect 8 0 4 0;
#P pop;
#P hidden newobj 208 265 45 196617 p revert;
#P window setfont "Sans Serif" 10.;
#P comment 30 266 138 196618 FIlters Overview;
#P objectname __revertbutton__[1];
#P user ubutton 26 264 113 19 0 6;
#P window setfont "Sans Serif" 14.;
#P comment 26 241 203 196622 Synthesis - filters;
#P user panel 26 264 114 18;
#X brgb 200 200 200;
#X frgb 0 0 0;
#X border 1;
#X rounded 8;
#X shadow 2;
#X done;
#P window setfont "Sans Serif" 9.;
#P comment 403 171 150 196617 Copy a signal into a buffer~;
#P message 343 170 59 196617 record~;
#P comment 402 200 260 196617 Phase-driven oscillator using a buffer~ as a wavetable;
#P message 343 198 59 196617 wave~;
#P comment 403 183 207 196617 grab and play a snippet of recent audio input;
#P message 343 184 59 196617 stutter~;
#P comment 403 157 232 196617 Write into a buffer~ using a signal sample index;
#P message 343 156 59 196617 poke~;
#P comment 106 596 200 196617 Convert number of samples to ms. values;
#P message 26 595 79 196617 sampstoms~;
#P comment 106 582 220 196617 Elminate noise in a muted subpatcher;
#P message 26 581 79 196617 pass~;
#P comment 106 568 199 196617 Disable signal objects in a patcher;
#P message 26 567 79 196617 mute~;
#P comment 106 555 216 196617 Convert ms. values to a number of samples;
#P message 26 554 79 196617 mstosamps~;
#P window linecount 5;
#P hidden message 449 778 154 196617 \; max launchbrowser "c:/Program Files/Cycling '74/MaxMSP 4.5/Documentation/MSP45ReferenceManual.pdf";
#P window linecount 1;
#P comment 747 481 199 196617 Truncate fractional part of signal values;
#P message 687 480 59 196617 trunc~;
#P comment 82 171 171 196617 Record signals to soundfiles on disk;
#P message 26 170 57 196617 sfrecord~;
#P comment 82 157 137 196617 Soundfile playback;
#P message 26 156 57 196617 sfplay~;
#P comment 82 143 146 196617 Store a list of sound file cues;
#P message 26 142 57 196617 sflist~;
#P comment 82 129 183 196617 Report information about a sound file;
#P message 26 128 57 196617 sfinfo~;
#P comment 82 115 147 196617 Control devices using ReWire;
#P message 26 114 57 196617 rewire~;
#P comment 101 455 127 196617 a jumpy line~;
#P comment 101 441 127 196617 a triangle/ramp wavetable;
#P message 26 454 75 196617 zigzag~;
#P message 26 440 75 196617 triangle~;
#P comment 763 269 213 196617 a zerocrossing counter / transient detector;
#P message 687 268 75 196617 zerox~;
#P comment 763 255 199 196617 detect when input goes above a set value;
#P message 687 254 75 196617 thresh~;
#P comment 763 241 201 196617 syncs MSP with MIDI \, click \, or tap tempo;
#P message 687 240 75 196617 sync~;
#P comment 763 228 231 196617 Report intervals of zero to non-zero transitions;
#P comment 763 213 172 196617 Report sample values from a signal;
#P message 687 212 75 196617 snapshot~;
#P comment 763 199 180 196617 report the peak amplitude of a signal;
#P message 687 198 75 196617 peakamp~;
#P comment 763 185 178 196617 computes signal min and max values;
#P message 687 184 75 196617 minmax~;
#P window setfont "Sans Serif" 14.;
#P comment 26 489 228 196622 System;
#P window setfont "Sans Serif" 9.;
#P comment 403 46 135 196617 2d Phase-driven oscillator;
#P message 343 45 59 196617 2d.wave~;
#P window setfont "Sans Serif" 14.;
#P comment 343 18 228 196622 Sampling/buffers;
#P window setfont "Sans Serif" 9.;
#P comment 747 467 180 196617 round signal to nearest integer value;
#P message 687 466 59 196617 round~;
#P comment 747 453 166 196617 Time-scale a phasor~;
#P message 687 452 59 196617 rate~;
#P comment 763 171 171 196617 output the minimum of two signals;
#P message 687 170 75 196617 minimum~;
#P comment 412 370 140 196617 Delay calculated in samples;
#P message 343 368 68 196617 delay~;
#P comment 82 101 171 196617 Simple iconic 2 channel audio output;
#P message 26 100 57 196617 ezdac~;
#P comment 101 343 152 196617 Exponential ramp generator;
#P message 26 342 75 196617 curve~;
#P comment 747 425 202 196617 fold or wrap a signal within a given range;
#P message 687 424 59 196617 pong~;
#P comment 413 486 134 196617 Peak Limiter;
#P message 343 486 70 196617 omx.peaklim~;
#P comment 747 439 202 196617 smooth out an incoming signal via a ramp;
#P window linecount 2;
#P message 687 438 59 196617 rampsmooth~;
#P window linecount 1;
#P comment 106 541 200 196617 Report time since audio was turned on;
#P message 26 540 79 196617 dsptime~;
#P comment 106 527 219 196617 Report info about current DSP settings;
#P message 26 526 79 196617 dspstate~;
#P message 343 318 56 196617 thispoly~;
#P comment 745 558 179 196617 Signal switching / mixing matrix;
#P comment 399 277 175 196617 output in a patcher loaded by poly~;
#P message 343 276 56 196617 out;
#P comment 399 263 235 196617 Define a signal input in a patcher loaded by poly~;
#P message 343 262 56 196617 in~;
#P window setfont "Sans Serif" 14.;
#P comment 343 220 271 196622 Polyphony;
#P window setfont "Sans Serif" 9.;
#P comment 399 249 169 196617 input in a patcher loaded by poly~;
#P message 343 248 56 196617 in;
#P comment 399 291 202 196617 signal output in a patcher loaded by poly~;
#P message 343 290 56 196617 out~;
#P comment 747 369 166 196617 downsample a signal;
#P message 687 368 59 196617 downsamp~;
#P comment 399 319 177 196617 controls voice allocation and muting;
#P comment 101 469 136 196617 Sample-and-hold;
#P message 26 468 75 196617 sah~;
#P comment 101 427 124 196617 a trapezoidal wavetable;
#P comment 101 413 145 196617 signal-based step sequencing;
#P message 26 426 75 196617 trapezoid~;
#P message 26 412 75 196617 techno~;
#P comment 101 399 171 196617 Output a constant value as a signal;
#P message 26 398 75 196617 sig~;
#P comment 101 385 143 196617 Signal input event sequencer;
#P message 26 384 75 196617 seq~;
#P comment 101 371 187 196617 Generate a band-limited random signal;
#P message 26 370 75 196617 rand~;
#P comment 101 357 168 196617 Generate signal ramp or envelope;
#P message 26 356 75 196617 line~;
#P comment 101 329 127 196617 Signal counter;
#P message 26 328 75 196617 count~;
#P comment 101 315 127 196617 classic adsr envelope;
#P message 26 314 75 196617 adsr~;
#P window setfont "Sans Serif" 14.;
#P comment 26 291 219 196622 Functions/generators;
#P window setfont "Sans Serif" 9.;
#P comment 745 545 193 196617 Switch input to different output signals;
#P comment 745 531 246 196617 Define the beginning of a signal processing network.;
#P message 687 543 57 196617 gate~;
#P message 687 529 57 196617 begin~;
#P window setfont "Sans Serif" 14.;
#P comment 687 503 228 196622 Signal routing;
#P window setfont "Sans Serif" 9.;
#P comment 413 472 137 196617 Compressor / Gate;
#P message 343 472 70 196617 omx.comp~;
#P comment 413 458 137 196617 5 Band Dynamics Processor;
#P comment 413 444 137 196617 4 Band Dynamics Processor;
#P message 343 458 70 196617 omx.5band~;
#P message 343 444 70 196617 omx.4band~;
#P window setfont "Sans Serif" 14.;
#P comment 343 416 185 196622 Dynamics;
#P window setfont "Sans Serif" 9.;
#P comment 82 87 173 196617 Simple iconic 2 channel audio input;
#P message 26 86 57 196617 ezadc~;
#P comment 82 73 137 196617 Audio output;
#P message 26 72 57 196617 dac~;
#P comment 82 59 179 196617 Access audio driver output channels;
#P message 26 58 57 196617 adoutput~;
#P window setfont "Sans Serif" 14.;
#P comment 26 18 204 196622 Audio I/O;
#P window setfont "Sans Serif" 9.;
#P hidden newex 63 853 44 196617 onecopy;
#P comment 403 115 234 196617 Use a buffer~ for nonlinear distortion of a signal;
#P message 343 114 59 196617 lookup~;
#P hidden message 887 430 158 196617 window flags grow \, window exec;
#P hidden message 887 371 239 196617 window flags nogrow \, window exec \, savewindow 1;
#N thispatcher;
#Q window flags grow close zoom nofloat;
#Q window size 139 44 1186 830;
#Q window title;
#Q window exec;
#Q savewindow 1;
#Q end;
#P hidden newobj 941 489 59 196617 thispatcher;
#N vpatcher 40 55 717 378;
#P outlet 121 222 15 0;
#P window setfont "Sans Serif" 9.;
#P message 135 161 228 196617 script send __revertbutton__ frgb 255 255 255;
#P message 121 143 192 196617 script send __revertbutton__ frgb 0 0 0;
#P newex 144 55 40 196617 change;
#P message 178 186 65 196617 restorestate;
#P newex 144 77 40 196617 sel 0 1;
#P message 75 107 140 196617 shadow 2 \, brgb 200 200 200;
#P message 109 125 145 196617 shadow -2 \, brgb 140 140 140;
#P outlet 178 222 15 0;
#P inlet 144 36 15 0;
#P inlet 109 36 15 0;
#P inlet 75 36 15 0;
#P outlet 75 222 15 0;
#P connect 1 0 6 0;
#P connect 7 0 6 0;
#P connect 6 0 0 0;
#P connect 5 0 0 0;
#P connect 2 0 5 0;
#P connect 7 1 5 0;
#P connect 1 0 10 0;
#P connect 7 0 10 0;
#P connect 11 0 12 0;
#P connect 10 0 12 0;
#P connect 7 1 11 0;
#P connect 2 0 11 0;
#P connect 3 0 9 0;
#P connect 9 0 7 0;
#P connect 1 0 8 0;
#P connect 8 0 4 0;
#P pop;
#P hidden newobj 1237 116 45 196617 p revert;
#P window setfont "Sans Serif" 10.;
#P comment 691 47 138 196618 Operator Overview;
#P objectname __revertbutton__;
#P user ubutton 687 46 113 19 0 6;
#P window setfont "Sans Serif" 14.;
#P comment 687 18 203 196622 Signal math;
#P window setfont "Sans Serif" 9.;
#N vpatcher 486 128 1154 450;
#P setbglock 1;
#P window setfont "Sans Serif" 9.;
#P comment 402 20 257 196617 Signal-rate linear Amplitude to deciBel Gain conversion;
#B color 15;
#P comment 86 235 201 196617 Arc-cosine function (acos(x)) for signals;
#B color 15;
#P message 11 234 75 196617 acos~;
#P comment 86 192 177 196617 Signal greater-than operator;
#B color 15;
#P message 11 190 75 196617 >~;
#P comment 86 135 237 196617 less than or equal to signal operator;
#B color 15;
#P comment 403 175 248 196617 Signal-rate deciBel Gain to linear Amplitude conversion;
#B color 15;
#P message 327 174 75 196617 dbtoa~;
#P comment 402 160 248 196617 cosine function for use with 0-1 input from phasor~;
#B color 15;
#P message 327 159 75 196617 cos~;
#P comment 402 261 248 196617 sin(x) for signals;
#B color 15;
#P message 327 259 75 196617 sinx~;
#P comment 86 207 177 196617 Absolute value of a signal;
#B color 15;
#P message 11 205 75 196617 abs~;
#P comment 87 93 124 196617 Signal addition operator;
#B color 15;
#P message 11 91 75 196617 +~;
#P message 11 134 75 196617 <=~;
#P hidden inlet 19 451 15 0;
#P hidden newex 35 450 38 196617 t front;
#P hidden message 58 2 158 196617 window flags grow \, window exec;
#P hidden message 64 10 239 196617 window flags nogrow \, window exec \, savewindow 1;
#N thispatcher;
#Q window flags nogrow close zoom nofloat;
#Q window size 486 128 1154 450;
#Q window title;
#Q window exec;
#Q savewindow 1;
#Q end;
#P hidden newobj 77 450 59 196617 thispatcher;
#P comment 402 303 248 196617 tan(x) for signals;
#B color 15;
#P message 327 302 75 196617 tanx~;
#P comment 402 289 248 196617 Hyperbolic tangent function (tanh(x)) for signals;
#B color 15;
#P message 327 288 75 196617 tanh~;
#P comment 402 275 257 196617 Square root of a signal;
#B color 15;
#P message 327 274 75 196617 sqrt~;
#P comment 402 118 189 196617 Bitwise xor signal operator.;
#B color 15;
#P message 327 117 75 196617 bitxor~;
#P comment 402 246 194 196617 Hyperbolic sine function (sinh(x)) for signals;
#B color 15;
#P message 327 245 75 196617 sinh~;
#P comment 402 232 203 196617 Take base to the exponent power using signals;
#B color 15;
#P message 327 231 75 196617 pow~;
#P comment 402 218 183 196617 Signal-rate MIDI to Frequency conversion;
#B color 15;
#P message 327 217 75 196617 mtof~;
#P comment 402 204 238 196617 Output the log (to a specified base) of a signal;
#B color 15;
#P message 327 203 75 196617 log~;
#P comment 402 190 253 196617 Signal-rate Frequency to MIDI conversion;
#B color 15;
#P message 327 189 75 196617 ftom~;
#P comment 402 146 230 196617 cos(x) for signals;
#B color 15;
#P message 327 145 75 196617 cosx~;
#P comment 402 132 231 196617 Hyperbolic cosine function (cosh(x)) for signals;
#B color 15;
#P message 327 131 75 196617 cosh~;
#P comment 402 104 261 196617 Bitwise shift signal operator.;
#B color 15;
#P message 327 103 75 196617 bitshift~;
#P comment 402 90 261 196617 Bitwise or signal operator.;
#B color 15;
#P message 327 89 75 196617 bitor~;
#P comment 402 76 261 196617 Bitwise not signal operator.;
#B color 15;
#P message 327 75 75 196617 bitnot~;
#P comment 402 62 261 196617 Bitwise and signal operator.;
#B color 15;
#P message 327 61 75 196617 bitand~;
#P comment 402 48 261 196617 Compute the average value of a signal;
#B color 15;
#P message 327 47 75 196617 avg~;
#P comment 402 34 240 196617 reports various forms of average value of signal;
#B color 15;
#P message 327 33 75 196617 average~;
#P message 327 19 75 196617 atodb~;
#P comment 402 8 201 196617 Arc-tangent function (atan(x)) for signals;
#B color 15;
#P message 327 5 75 196617 atan~;
#P comment 86 291 231 196617 Arc Hyperbolic tangent function (atanh(x)) for signals;
#B color 15;
#P message 11 290 75 196617 atanh~;
#P comment 86 277 201 196617 Standard C function for arctan(y/x);
#B color 15;
#P message 11 276 75 196617 atan2~;
#P comment 86 263 163 196617 Arc-sine function (asin(x)) for signals;
#B color 15;
#P message 11 262 75 196617 asin~;
#P comment 86 249 216 196617 Arc Hyperbolic sine function (asinh(x)) for signals;
#B color 15;
#P message 11 248 75 196617 asinh~;
#P comment 87 222 236 196617 Arc Hyperbolic cosine function (acosh(x)) for signals;
#B color 15;
#P message 11 220 75 196617 acosh~;
#P comment 86 177 237 196617 greater than or equal to signal operator;
#B color 15;
#P message 11 176 75 196617 >=~;
#P comment 86 163 237 196617 Signal equal-to operator;
#B color 15;
#P message 11 162 75 196617 ==~;
#P comment 86 149 237 196617 Signal less-than operator;
#B color 15;
#P message 11 148 75 196617 <~;
#P comment 86 121 237 196617 Signal divide operator;
#B color 15;
#P message 11 120 75 196617 /~;
#P comment 86 107 237 196617 produces the difference between two signals;
#B color 15;
#P message 11 106 75 196617 -~;
#P comment 86 78 251 196617 Signal multiply operator;
#B color 15;
#P message 11 77 75 196617 *~;
#P comment 86 36 242 196617 quotient between the right and the left signal inputs;
#B color 15;
#P message 11 35 75 196617 !/~;
#P comment 86 50 238 196617 not equal signal operator;
#B color 15;
#P message 11 49 75 196617 !=~;
#P comment 86 22 231 196617 difference between the right and the left signal inputs;
#B color 15;
#P comment 86 64 237 196617 Signal remainder operator;
#B color 15;
#P hidden newex 208 459 45 196617 pcontrol;
#P hidden newex 208 437 64 196617 prepend help;
#P message 11 63 75 196617 %~;
#P message 11 21 75 196617 !-~;
#P window setfont "Sans Serif" 14.;
#P comment 5 1 148 196622 Operators;
#B color 15;
#P user panel -2 -1 670 324;
#X brgb 51 51 51;
#X frgb 0 0 0;
#X border 1;
#X rounded 0;
#X shadow 1;
#X done;
#P background;
#P hidden connect 75 0 74 0;
#P hidden connect 74 0 71 0;
#P hidden connect 73 0 71 0;
#P hidden connect 72 0 71 0;
#P hidden connect 90 0 4 0;
#P hidden connect 88 0 4 0;
#P hidden connect 69 0 4 0;
#P hidden connect 67 0 4 0;
#P hidden connect 65 0 4 0;
#P hidden connect 63 0 4 0;
#P hidden connect 61 0 4 0;
#P hidden connect 59 0 4 0;
#P hidden connect 57 0 4 0;
#P hidden connect 55 0 4 0;
#P hidden connect 53 0 4 0;
#P hidden connect 3 0 4 0;
#P hidden connect 2 0 4 0;
#P hidden connect 8 0 4 0;
#P hidden connect 10 0 4 0;
#P hidden connect 12 0 4 0;
#P hidden connect 14 0 4 0;
#P hidden connect 16 0 4 0;
#P hidden connect 18 0 4 0;
#P hidden connect 20 0 4 0;
#P hidden connect 22 0 4 0;
#P hidden connect 24 0 4 0;
#P hidden connect 26 0 4 0;
#P hidden connect 28 0 4 0;
#P hidden connect 30 0 4 0;
#P hidden connect 32 0 4 0;
#P hidden connect 34 0 4 0;
#P hidden connect 36 0 4 0;
#P hidden connect 37 0 4 0;
#P hidden connect 39 0 4 0;
#P hidden connect 41 0 4 0;
#P hidden connect 43 0 4 0;
#P hidden connect 45 0 4 0;
#P hidden connect 47 0 4 0;
#P hidden connect 49 0 4 0;
#P hidden connect 51 0 4 0;
#P hidden connect 76 0 4 0;
#P hidden connect 77 0 4 0;
#P hidden connect 79 0 4 0;
#P hidden connect 81 0 4 0;
#P hidden connect 83 0 4 0;
#P hidden connect 85 0 4 0;
#P hidden connect 4 0 5 0;
#P pop;
#P hidden newobj 687 70 69 196617 p operators;
#P comment 106 513 198 196617 Report audio processing information;
#P message 26 512 79 196617 adstatus;
#P comment 747 411 218 196617 Apply nonlinear transfer function to a signal.;
#P message 687 410 59 196617 overdrive~;
#P comment 403 73 185 196617 Variable-rate looping sample playback;
#P message 343 72 59 196617 groove~;
#P comment 747 327 164 196617 signal degradation;
#P message 687 326 59 196617 degrade~;
#P comment 763 157 174 196617 output the maximum of two signals;
#P message 687 156 75 196617 maximum~;
#P comment 763 143 202 196617 Detect zero to non-zero signal transitions;
#P message 687 142 75 196617 edge~;
#P comment 763 129 178 196617 Signal counter;
#P message 687 128 75 196617 count~;
#P comment 763 115 166 196617 Detect signal change and direction;
#P message 687 114 75 196617 change~;
#P comment 747 397 226 196617 Scale a signal based on its maximum amplitude;
#P message 687 396 59 196617 normalize~;
#P comment 747 383 162 196617 a time-domain frequency shifter;
#P message 687 382 59 196617 freqshift~;
#P comment 403 143 243 196617 Sample playback based on position within a buffer~;
#P message 343 142 59 196617 play~;
#P comment 403 59 179 196617 Multichannel sample buffer;
#P message 343 58 59 196617 buffer~;
#P comment 403 129 207 196617 Read and write buffer~ values;
#P message 343 128 59 196617 peek~;
#P comment 403 101 245 196617 loop and sample pitch information from a buffer~;
#P message 343 100 59 196617 info~;
#P comment 412 398 144 196617 Output from signal delay line;
#P comment 745 600 170 196617 Send a signal without a patch cord;
#P message 687 599 57 196617 send~;
#P comment 745 586 207 196617 Switch output among several input signals;
#P message 687 585 57 196617 selector~;
#P comment 745 572 234 196617 Receive a signal from one or more send~ objects;
#P message 687 571 57 196617 receive~;
#P comment 747 313 187 196617 Constrain a signal between two values;
#P message 687 312 59 196617 clip~;
#P message 343 396 68 196617 tapout~;
#P window setfont "Sans Serif" 14.;
#P comment 343 340 240 196622 Delays;
#P window setfont "Sans Serif" 9.;
#P comment 412 384 160 196617 Input to signal delay line;
#P message 343 382 68 196617 tapin~;
#P comment 403 87 138 196617 index based sample reading;
#P message 343 86 59 196617 index~;
#P comment 747 355 281 196617 creates differences between successive samples;
#P message 687 354 59 196617 delta~;
#P comment 82 45 206 196617 Output audio from computer's input source;
#P message 26 44 57 196617 adc~;
#P comment 747 341 208 196617 Limit the change between samples in signal;
#P window setfont "Sans Serif" 14.;
#P comment 687 285 230 196622 Signal modifiers;
#P window setfont "Sans Serif" 9.;
#P message 687 340 59 196617 deltaclip~;
#P comment 763 101 149 196617 Store a signal to view as text;
#P comment 399 305 200 196617 Polyphony and DSP manager for patchers;
#P message 343 304 56 196617 poly~;
#P message 687 100 75 196617 capture~;
#P window setfont "Sans Serif" 14.;
#P comment 687 73 175 196622 Signal analysis;
#P window setfont "Sans Serif" 9.;
#P hidden newex 651 637 45 196617 pcontrol;
#P hidden newex 651 621 64 196617 prepend help;
#P user panel 687 46 114 18;
#X brgb 200 200 200;
#X frgb 0 0 0;
#X border 1;
#X rounded 8;
#X shadow 2;
#X done;
#P message 687 557 57 196617 matrix~;
#P window setfont "Sans Serif" 20.;
#P comment 700 652 51 196628 MSP;
#P window setfont "Sans Serif" 9.;
#P message 687 226 75 196617 spike~;
#P user ubutton 694 638 64 61 0 6;
#P user fpic 686 631 78 74 msp.jpg 0 0 0 0. 0 0 3;
#P user panel 0 1 1022 763;
#X brgb 166 114 115;
#X frgb 0 0 0;
#X border 1;
#X rounded 0;
#X shadow 1;
#X done;
#P background;
#P hidden fasten 208 0 204 0 213 239 187 239 152 210 31 210;
#P hidden connect 206 0 215 0;
#P hidden fasten 203 0 199 0 213 288 187 288 152 259 31 259;
#P hidden connect 201 0 214 0;
#P hidden fasten 206 0 208 0 31 244 154 244 186 213 213 213;
#P hidden fasten 201 0 203 0 31 293 154 293 186 262 213 262;
#P hidden fasten 206 1 208 1 65 242 153 242 185 211 230 211;
#P hidden fasten 201 1 203 1 65 291 153 291 185 260 230 260;
#P hidden fasten 206 3 208 2 133 240 153 240 183 209 247 209;
#P hidden fasten 201 3 203 2 133 289 153 289 183 258 247 258;
#P hidden fasten 221 0 217 0 514 555 488 555 453 526 348 526;
#P hidden connect 219 0 222 0;
#P hidden fasten 213 0 209 0 536 605 510 605 475 576 348 576;
#P hidden connect 211 0 216 0;
#P hidden connect 2 1 182 0;
#P hidden fasten 219 0 221 0 348 560 455 560 487 529 514 529;
#P hidden fasten 219 1 221 1 382 558 454 558 486 527 531 527;
#P hidden fasten 211 0 213 0 348 610 477 610 509 579 536 579;
#P hidden fasten 219 3 221 2 450 556 454 556 484 525 548 525;
#P hidden fasten 211 1 213 1 382 608 476 608 508 577 553 577;
#P hidden fasten 211 3 213 2 450 606 476 606 506 575 570 575;
#P hidden connect 180 0 7 0;
#P hidden connect 178 0 7 0;
#P hidden connect 176 0 7 0;
#P hidden connect 174 0 7 0;
#P hidden connect 172 0 7 0;
#P hidden connect 170 0 7 0;
#P hidden connect 167 0 7 0;
#P hidden connect 166 0 7 0;
#P hidden connect 147 0 7 0;
#P hidden connect 145 0 7 0;
#P hidden connect 141 0 7 0;
#P hidden connect 139 0 7 0;
#P hidden connect 137 0 7 0;
#P hidden connect 135 0 7 0;
#P hidden connect 38 0 7 0;
#P hidden connect 54 0 7 0;
#P hidden connect 52 0 7 0;
#P hidden connect 50 0 7 0;
#P hidden connect 48 0 7 0;
#P hidden connect 46 0 7 0;
#P hidden connect 44 0 7 0;
#P hidden connect 42 0 7 0;
#P hidden connect 40 0 7 0;
#P hidden connect 36 0 7 0;
#P hidden connect 33 0 7 0;
#P hidden connect 31 0 7 0;
#P hidden connect 29 0 7 0;
#P hidden connect 27 0 7 0;
#P hidden connect 26 0 7 0;
#P hidden connect 23 0 7 0;
#P hidden connect 21 0 7 0;
#P hidden connect 19 0 7 0;
#P hidden connect 17 0 7 0;
#P hidden connect 14 0 7 0;
#P hidden connect 11 0 7 0;
#P hidden connect 10 0 7 0;
#P hidden connect 56 0 7 0;
#P hidden connect 60 0 7 0;
#P hidden connect 62 0 7 0;
#P hidden connect 58 0 7 0;
#P hidden connect 72 0 7 0;
#P hidden connect 76 0 7 0;
#P hidden connect 78 0 7 0;
#P hidden connect 80 0 7 0;
#P hidden connect 87 0 7 0;
#P hidden connect 84 0 7 0;
#P hidden connect 83 0 7 0;
#P hidden connect 90 0 7 0;
#P hidden connect 91 0 7 0;
#P hidden connect 111 0 7 0;
#P hidden connect 108 0 7 0;
#P hidden connect 107 0 7 0;
#P hidden connect 105 0 7 0;
#P hidden connect 103 0 7 0;
#P hidden connect 101 0 7 0;
#P hidden connect 99 0 7 0;
#P hidden connect 97 0 7 0;
#P hidden connect 95 0 7 0;
#P hidden connect 126 0 7 0;
#P hidden connect 114 0 7 0;
#P hidden connect 116 0 7 0;
#P hidden connect 123 0 7 0;
#P hidden connect 121 0 7 0;
#P hidden connect 118 0 7 0;
#P hidden connect 127 0 7 0;
#P hidden connect 129 0 7 0;
#P hidden connect 131 0 7 0;
#P hidden connect 5 0 7 0;
#P hidden connect 133 0 7 0;
#P hidden connect 143 0 7 0;
#P hidden connect 153 0 7 0;
#P hidden connect 155 0 7 0;
#P hidden connect 157 0 7 0;
#P hidden connect 3 0 7 0;
#P hidden connect 160 0 7 0;
#P hidden connect 162 0 7 0;
#P hidden connect 164 0 7 0;
#P hidden connect 150 0 7 0;
#P hidden connect 191 0 7 0;
#P hidden connect 197 0 7 0;
#P hidden connect 193 0 7 0;
#P hidden connect 195 0 7 0;
#P hidden connect 183 0 7 0;
#P hidden connect 185 0 7 0;
#P hidden connect 187 0 7 0;
#P hidden connect 189 0 7 0;
#P hidden connect 7 0 8 0;
#P hidden fasten 68 0 6 0 1242 139 1216 139 1181 110 692 110;
#P hidden connect 66 0 64 0;
#P hidden connect 71 0 69 0;
#P hidden connect 70 0 69 0;
#P hidden fasten 66 0 68 0 692 144 1183 144 1215 113 1242 113;
#P hidden fasten 66 1 68 1 726 142 1182 142 1214 111 1259 111;
#P hidden fasten 66 3 68 2 794 140 1182 140 1212 109 1276 109;
#P pop;
